Raritan PX2/PX3 JSON-RPC API

LdapManager.idl
1 /* SPDX-License-Identifier: BSD-3-Clause */
2 /*
3 * Copyright 2010 Raritan Inc. All rights reserved.
4 */
5
6 #include "LdapServerSettings.idl"
7
8 /** Local and Remote Authentication Management */
9 module auth {
10
11 /** LDAP server configuration interface */
12 interface LdapManager_2_0_0 {
13
14 /**
15 * Get a list of LDAP server settings
16 *
17 * @return list of ldapsrv.ServerSettings
18 */
19 vector<ldapsrv.ServerSettings_2_0_0> getLdapServers();
20
21 constant int ERR_CYCLIC_DEP = 1; ///< Cyclic dependency in server list
22 constant int ERR_INVALID_CFG = 2; ///< The server configuration is invalid
23 /**
24 * Sets a list of LDAP servers.
25 * Any existing LDAP Server configuration will be cleared / overwritten.
26 *
27 * @return 0 on success
28 * @return \c ERR_CYCLIC_DEP in case of cyclic dependency
29 * @return \c ERR_INVALID_CFG in case of invalid configuration
30 */
31 int setLdapServers(in vector<ldapsrv.ServerSettings_2_0_0> serverList);
32
33 constant int ERR_SERVER_UNSPECIFIED = 1; ///< Unspecified error
34 constant int ERR_SERVER_UNREACHABLE = 3; ///< LDAP server could not be contacted
35 constant int ERR_AUTHENTICATION_FAILED = 4; ///< User could not be authenticated
36 constant int ERR_NO_ROLES = 5; ///< No roles are defined for the user
37 constant int ERR_NO_KNOWN_ROLES = 6; ///< No known rules are defined for the user
38 /**
39 * Tests an LDAP server configuration.
40 *
41 * @return 0 on success
42 * @return \c ERR_SERVER_UNSPECIFIED an unspecified error occurred
43 * @return \c ERR_INVALID_CFG LDAP server configuration is invalid (reused from setLdapServers)
44 * @return \c ERR_SERVER_UNREACHABLE LDAP server could not be contacted
45 * @return \c ERR_AUTHENTICATION_FAILED user could not be authenticated
46 * @return \c ERR_NO_ROLES no roles are defined for the user
47 * @return \c ERR_NO_KNOWN_ROLES no known roles are defined for the user
48 */
49 int testLdapServer(in string username, in string password, in ldapsrv.ServerSettings_2_0_0 settings, out string diagMsg);
50
51 };
52
53 }
auth
Local and Remote Authentication Management.
Definition: AuthManager.idl:7
auth::LdapManager_2_0_0
LDAP server configuration interface.
Definition: LdapManager.idl:12